if string.lower(RequiredScript) == "lib/managers/localizationmanager" then
	Hooks:Add("LocalizationManagerPostInit", "CrimeNET_Enhanced_loc", function(...)
		if Idstring("schinese"):key() == SystemInfo:language():key() then
			LocalizationManager:add_localized_strings({
				menu_hide_blacklisted = "隐藏安装有黑名单中的模组的大厅",
				menu_hide_unmodded = "隐藏未安装模组的大厅",
				menu_cn_legend_inlobby = "##在大厅##的合约",
				menu_cn_legend_ingame = "##劫案中##的合约",
				menu_cn_legend_inbriefing = "##载入中或在简报页面##的合约",
				menu_cn_legend_unmodded = "##未安装模组##的合约",
				menu_cn_legend_modded = " ##已安装模组##的合约",
				menu_cn_legend_blacklisted = "##安装了黑名单中的模组##的合约",
				menu_cn_legend_banned = "主机被您 ##拉入黑名单##的合约",
				menu_cn_legend_right_btn = "将主机拉入##黑名单##",
				menu_cn_legend_middle_button = "将主机拉入##黑名单## （在合约预览界面）",
				menu_cn_legend_right_btn_mods = "将模组添加进 ##黑名单## （在合约预览界面）",
			})
		elseif Idstring("russian"):key() == SystemInfo:language():key() then
			LocalizationManager:add_localized_strings({
				menu_hide_blacklisted = "Скрыть лобби c модиф. из черного списка",
				menu_hide_unmodded = "Скрыть лобби без модификаций",
				menu_cn_legend_inlobby = "Контракты ##в Лобби##",
				menu_cn_legend_ingame = "Контракты ##в Игре##",
				menu_cn_legend_inbriefing = "Контракты ##в Загрузке или Брифинге##",
				menu_cn_legend_modded = "Контракты ##С модификациями##",
				menu_cn_legend_unmodded = "Контракты ##Без модификациями##",
				menu_cn_legend_blacklisted = "Контракты ##С модификациями из черного списка##",
				menu_cn_legend_banned = "Лидер лобби ##в бан-листе##",
				menu_cn_legend_right_btn = "Добавить хоста в ##бан-лист##",
				menu_cn_legend_middle_button = "Добавить хоста в ##бан-лист## (в предпросмотре контракта)",
				menu_cn_legend_right_btn_mods = "Добавить мод. в ##черный список## (в предпросмотре контракта)",
			})
		else				
			LocalizationManager:add_localized_strings({
				menu_hide_blacklisted = "Hide lobbies with blacklisted mods",
				menu_hide_unmodded = "Hide unmodded lobbies",
				menu_cn_legend_inlobby = "Contracts ##in Lobby##",
				menu_cn_legend_ingame = "Contracts ##in Game##",
				menu_cn_legend_inbriefing = "Contracts ##in Loading or Briefing##",
				menu_cn_legend_unmodded = "Contracts ##Unodded##",
				menu_cn_legend_modded = "Contracts ##Modded##",
				menu_cn_legend_blacklisted = "Contracts ##with Blacklisted Mods##",
				menu_cn_legend_banned = "Host of the contract ##is in the Ban List##",
				menu_cn_legend_right_btn = "Add host to the ##Ban List##",
				menu_cn_legend_middle_button = "Add host to the ##Ban List## (in Contract Previev)",
				menu_cn_legend_right_btn_mods = "Add mod to the ##Black List## (in Contract Previev)",
			})
		end
	end)

	_G.CN_Enhanced = _G.CN_Enhanced or {}
	CN_Enhanced._mod_path = CN_Enhanced._mod_path or ModPath
	CN_Enhanced._setting_path = SavePath .. "CrimeNET_Enhanced.json"
	CN_Enhanced.settings = CN_Enhanced.settings or {}
	
	function CN_Enhanced:find_in_table(required_table, value)
		local table_to_string = string.upper(table.concat(required_table, "  "))
		local function precise(text)
			return text:gsub("%p", "").."  "
		end
		if string.match(precise(table_to_string), precise(value)) == precise(value) then
			return true
		elseif string.match(precise(table_to_string), precise(value)) ~= precise(value) then
			return false
		end
	end
	
	Hooks:Add("MenuManagerOnOpenMenu", "CNE_add_new_filters", function(self, menu)
		if menu == "menu_main" and not LuaNetworking:IsMultiplayer() then	
			local crimenet_filters = MenuHelperPlus:GetNode(nil, "crimenet_filters")
			local difficulty_settings = MenuHelperPlus:GetNode(nil, "difficulty_settings")
			
			local function add_toggle(name, node, params)
				MenuCallbackHandler["_"..name] = function(self, item)
					local val = item:value() == "on"
					CN_Enhanced.Options:SetValue(name, val)
				end
				
				MenuHelperPlus:AddToggle({
					id = name,
					title = params.title or "menu_"..name,
					node = node,
					value = CN_Enhanced.Options:GetValue(name),
					position = params.pos or 1,
					callback = params.call or "_"..name,
				})
			end
			
			add_toggle("hide_unmodded", crimenet_filters, {pos = 13})
			add_toggle("hide_blacklisted", crimenet_filters, {pos = 13})
		end
	end)
end
if string.lower(RequiredScript) == "lib/network/matchmaking/networkmatchmakingsteam" then
	local data = NetworkMatchMakingSTEAM.is_server_ok
	function NetworkMatchMakingSTEAM:is_server_ok(friends_only, room, attributes_list, is_invite)
		if CN_Enhanced.Options:GetValue("hide_unmodded") and attributes_list.mods == "1" then
			return false
		end
		
		if CN_Enhanced.Options:GetValue("hide_blacklisted") and managers.crimenet:unacceptable_mods_found(attributes_list) then
			return false
		end

		return data(self, friends_only, room, attributes_list, is_invite)
	end
end
if string.lower(RequiredScript) == "lib/managers/menu/crimenetcontractgui" then
	local data = CrimeNetContractGui.update
	function CrimeNetContractGui:update(t, dt)
		data(self, t, dt)
	
		if self._mod_items and self._mods_tab and self._mods_tab:is_active() then
			for _, item in ipairs(self._mod_items) do	
			
				local cne = _G.CN_Enhanced
				local mods_blacklist = cne.Options:GetValue("mods_blacklist")
				local mod_name = item[1]:text()
				local name_match = cne:find_in_table(mods_blacklist, mod_name)

				if mod_name then
					if not name_match then
						item[1]:set_color(Color(0.8, 0.8, 0.8))
						item[2]:set_color(tweak_data.screen_colors.button_stage_2)
					elseif name_match then
						item[1]:set_color(tweak_data.screen_colors.pro_color)
						item[2]:set_color(tweak_data.screen_colors.infamy_color)
					end
				end
				
			end
		end
	end
	
	local data = CrimeNetContractGui.mouse_pressed
	function CrimeNetContractGui:mouse_pressed(o, button, x, y)
		data(self, o, button, x, y)

		if self._mod_items and self._mods_tab and self._mods_tab:is_active() then
			if button == Idstring("1") then
				for _, item in ipairs(self._mod_items) do
					if item[1]:inside(x, y) then
		
						local cne = _G.CN_Enhanced
						local mods_blacklist = cne.Options:GetValue("mods_blacklist")
						local mod_name = item[1]:text()
						local name_match = cne:find_in_table(mods_blacklist, mod_name)
						
						if mod_name then
						
							if not name_match then
								table.insert(mods_blacklist, mod_name)
								cne.Options:Save()
							elseif name_match then
								for blacklisted_mod_id, blacklisted_mod_name in pairs(mods_blacklist) do
									if string.upper(blacklisted_mod_name) == mod_name then
										table.remove(mods_blacklist, blacklisted_mod_id)
										cne.Options:Save()
									end
								end
							end
								
							break
						end
						break
					end
				end
			end
		end
	end
end
if string.lower(RequiredScript) == "lib/managers/crimenetmanager" then
	local data = CrimeNetGui.init
	function CrimeNetGui:init(ws, fullscreeen_ws, node)
		data(self, ws, fullscreeen_ws, node)
		local legend_panel = self._panel:child("legend_panel")
		legend_panel:clear()

		local w, h = nil
		local mw = 0
		local mh = nil
		local host_icon = legend_panel:bitmap({
			texture = "guis/textures/pd2/crimenet_legend_host",
			x = 10,
			y = 10
		})
		local host_text = legend_panel:text({
			blend_mode = "add",
			font = tweak_data.menu.pd2_small_font,
			font_size = tweak_data.menu.pd2_small_font_size,
			x = host_icon:right() + 2,
			y = host_icon:top(),
			text = managers.localization:to_upper_text("menu_cn_legend_host")
		})
		mw = math.max(mw, self:make_fine_text(host_text))
		local next_y = host_text:bottom()
		
		local right_button_icon = legend_panel:bitmap({
			texture = "guis/textures/pd2/mouse_buttons",
			texture_rect = {18, 0, 17, 25},
			x = 10,
			w = 16,
			h = 21,
			y = next_y
		})
		local right_button_text = legend_panel:text({
			blend_mode = "add",
			font = tweak_data.menu.pd2_small_font,
			font_size = tweak_data.menu.pd2_small_font_size,
			x = host_text:left(),
			y = next_y,
			text = managers.localization:to_upper_text("menu_cn_legend_right_btn")
		})
		self:make_color_text(right_button_text, tweak_data.screen_colors.achievement_grey:with_alpha(1))
		mw = math.max(mw, self:make_fine_text(right_button_text))
		next_y = right_button_text:bottom()
		
		local middle_button_icon = legend_panel:bitmap({
			texture = "guis/textures/pd2/mouse_buttons",
			texture_rect = {35, 0, 17, 25},
			x = 10,
			w = 16,
			h = 21,
			y = next_y
		})
		local middle_button_text = legend_panel:text({
			blend_mode = "add",
			font = tweak_data.menu.pd2_small_font,
			font_size = tweak_data.menu.pd2_small_font_size,
			x = host_text:left(),
			y = next_y,
			text = managers.localization:to_upper_text("menu_cn_legend_middle_button")
		})
		self:make_color_text(middle_button_text, tweak_data.screen_colors.achievement_grey:with_alpha(1))
		mw = math.max(mw, self:make_fine_text(middle_button_text))
		next_y = middle_button_text:bottom()
		
		local right_button_mods_icon = legend_panel:bitmap({
			texture = "guis/textures/pd2/mouse_buttons",
			texture_rect = {18, 0, 17, 25},
			x = 10,
			w = 16,
			h = 21,
			y = next_y
		})
		local right_button_mods_text = legend_panel:text({
			blend_mode = "add",
			font = tweak_data.menu.pd2_small_font,
			font_size = tweak_data.menu.pd2_small_font_size,
			x = host_text:left(),
			y = next_y,
			text = managers.localization:to_upper_text("menu_cn_legend_right_btn_mods")
		})
		self:make_color_text(right_button_mods_text, tweak_data.screen_colors.pro_color)
		mw = math.max(mw, self:make_fine_text(right_button_mods_text))
		next_y = right_button_mods_text:bottom()
		
		
		local in_lobby_icon = legend_panel:bitmap({
			texture = "guis/textures/pd2/crimenet_legend_join",
			x = 10,
			color = Color(255, 114, 198, 255) / 255,
			y = next_y
		})
		local in_lobby_text = legend_panel:text({
			blend_mode = "add",
			font = tweak_data.menu.pd2_small_font,
			font_size = tweak_data.menu.pd2_small_font_size,
			x = host_text:left(),
			y = next_y,
			text = managers.localization:to_upper_text("menu_cn_legend_inlobby")
		})
		mw = math.max(mw, self:make_fine_text(in_lobby_text))
		self:make_color_text(in_lobby_text, Color(255, 114, 198, 255) / 255)
		next_y = in_lobby_text:bottom()
		
		local in_game_icon = legend_panel:bitmap({
			texture = "guis/textures/pd2/crimenet_legend_join",
			x = 10,
			color = Color(255, 163, 209, 93) / 255,
			y = next_y
		})
		local in_game_text = legend_panel:text({
			blend_mode = "add",
			font = tweak_data.menu.pd2_small_font,
			font_size = tweak_data.menu.pd2_small_font_size,
			x = host_text:left(),
			y = next_y,
			text = managers.localization:to_upper_text("menu_cn_legend_ingame")
		})
		mw = math.max(mw, self:make_fine_text(in_game_text))
		self:make_color_text(in_game_text, Color(255, 163, 209, 93) / 255)
		next_y = in_game_text:bottom()
		
		local in_briefing_icon = legend_panel:bitmap({
			texture = "guis/textures/pd2/crimenet_legend_join",
			x = 10,
			y = next_y
		})
		local in_briefing_text = legend_panel:text({
			blend_mode = "add",
			font = tweak_data.menu.pd2_small_font,
			font_size = tweak_data.menu.pd2_small_font_size,
			x = host_text:left(),
			y = next_y,
			text = managers.localization:to_upper_text("menu_cn_legend_inbriefing")
		})
		mw = math.max(mw, self:make_fine_text(in_briefing_text))
		self:make_color_text(in_briefing_text, tweak_data.screen_colors.text)
		next_y = in_briefing_text:bottom()
		
		local unmodded_icon = legend_panel:bitmap({
			texture = "guis/textures/pd2/equip_count",
			x = 10,
			w = 16,
			h = 16,
			color = tweak_data.screen_colors.crimenet_lines,
			y = next_y
		})
		local unmodded_text = legend_panel:text({
			blend_mode = "add",
			font = tweak_data.menu.pd2_small_font,
			font_size = tweak_data.menu.pd2_small_font_size,
			x = in_lobby_text:left(),
			y = next_y,
			text = managers.localization:to_upper_text("menu_cn_legend_unmodded")
		})
		mw = math.max(mw, self:make_fine_text(unmodded_text))
		self:make_color_text(unmodded_text, tweak_data.screen_colors.crimenet_lines)
		next_y = unmodded_text:bottom()
		
		local modded_icon = legend_panel:bitmap({
			texture = "guis/textures/pd2/equip_count",
			x = 10,
			w = 16,
			h = 16,
			color = tweak_data.screen_colors.regular_color,
			y = next_y
		})
		local modded_text = legend_panel:text({
			blend_mode = "add",
			font = tweak_data.menu.pd2_small_font,
			font_size = tweak_data.menu.pd2_small_font_size,
			x = in_lobby_text:left(),
			y = next_y,
			text = managers.localization:to_upper_text("menu_cn_legend_modded")
		})
		mw = math.max(mw, self:make_fine_text(modded_text))
		self:make_color_text(modded_text, tweak_data.screen_colors.regular_color)
		next_y = modded_text:bottom()
		
		local blacklisted_icon = legend_panel:bitmap({
			texture = "guis/textures/pd2/equip_count",
			x = 10,
			w = 16,
			h = 16,
			color = tweak_data.screen_colors.pro_color,
			y = next_y
		})
		local blacklisted_text = legend_panel:text({
			blend_mode = "add",
			font = tweak_data.menu.pd2_small_font,
			font_size = tweak_data.menu.pd2_small_font_size,
			x = in_lobby_text:left(),
			y = next_y,
			text = managers.localization:to_upper_text("menu_cn_legend_blacklisted")
		})
		mw = math.max(mw, self:make_fine_text(blacklisted_text))
		self:make_color_text(blacklisted_text, tweak_data.screen_colors.pro_color)
		next_y = blacklisted_text:bottom()
		
		local friends_icon = legend_panel:bitmap({
			texture = "guis/textures/pd2/equip_count",
			x = 10,
			y = next_y,
			w = 16,
			h = 16,
			color = tweak_data.screen_colors.friend_color
		})
		local friends_text = legend_panel:text({
			blend_mode = "add",
			font = tweak_data.menu.pd2_small_font,
			font_size = tweak_data.menu.pd2_small_font_size,
			x = host_text:left(),
			y = next_y,
			text = managers.localization:to_upper_text("menu_cn_legend_friends")
		})
		mw = math.max(mw, self:make_fine_text(friends_text))
		self:make_color_text(friends_text, tweak_data.screen_colors.friend_color)
		next_y = friends_text:bottom()

		local banned_icon = legend_panel:bitmap({
			texture = "guis/textures/pd2/equip_count",
			x = 10,
			w = 16,
			h = 16,
			color = tweak_data.screen_colors.achievement_grey:with_alpha(1),
			y = next_y
		})
		local banned_text = legend_panel:text({
			blend_mode = "add",
			font = tweak_data.menu.pd2_small_font,
			font_size = tweak_data.menu.pd2_small_font_size,
			x = in_lobby_text:left(),
			y = next_y,
			text = managers.localization:to_upper_text("menu_cn_legend_banned")
		})
		mw = math.max(mw, self:make_fine_text(banned_text))
		self:make_color_text(banned_text, tweak_data.screen_colors.achievement_grey:with_alpha(1))
		next_y = banned_text:bottom()
		
		if managers.crimenet:no_servers() or is_xb1 then
			next_y = host_text:bottom()
			right_button_icon:hide()
			right_button_text:hide()
			right_button_mods_icon:hide()
			right_button_mods_text:hide()
			middle_button_icon:hide()
			middle_button_text:hide()
			in_lobby_icon:hide()
			in_lobby_text:hide()
			in_game_icon:hide()
			in_game_text:hide()
			in_briefing_icon:hide()
			in_briefing_text:hide()
			unmodded_icon:hide()
			unmodded_text:hide()
			modded_icon:hide()
			modded_text:hide()
			blacklisted_icon:hide()
			blacklisted_text:hide()
			friends_icon:hide()
			friends_text:hide()
			banned_icon:hide()
			banned_text:hide()
			banned_text:set_bottom(next_y)
		end

		local mutated_icon = legend_panel:bitmap({
			texture = "guis/textures/pd2/crimenet_legend_host",
			x = 10,
			y = next_y,
			color = tweak_data.screen_colors.mutators_color_text
		})
		local mutated_text = legend_panel:text({
			blend_mode = "add",
			font = tweak_data.menu.pd2_small_font,
			font_size = tweak_data.menu.pd2_small_font_size,
			x = host_text:left(),
			y = next_y,
			text = managers.localization:to_upper_text("menu_cn_legend_mutated"),
			color = tweak_data.screen_colors.mutators_color_text
		})
		mw = math.max(mw, self:make_fine_text(mutated_text))
		next_y = mutated_text:bottom()
		
		local spree_icon = legend_panel:bitmap({
			texture = "guis/textures/pd2/crimenet_legend_host",
			x = 10,
			y = next_y,
			color = tweak_data.screen_colors.crime_spree_risk
		})
		local spree_text = legend_panel:text({
			blend_mode = "add",
			font = tweak_data.menu.pd2_small_font,
			font_size = tweak_data.menu.pd2_small_font_size,
			x = host_text:left(),
			y = next_y,
			text = managers.localization:to_upper_text("cn_crime_spree"),
			color = tweak_data.screen_colors.crime_spree_risk
		})
		mw = math.max(mw, self:make_fine_text(spree_text))
		next_y = spree_text:bottom()
		
		local skirmish_icon = legend_panel:bitmap({
			texture = "guis/textures/pd2/crimenet_legend_host",
			x = 10,
			y = next_y,
			color = tweak_data.screen_colors.skirmish_color
		})
		local skirmish_text = legend_panel:text({
			blend_mode = "add",
			font = tweak_data.menu.pd2_small_font,
			font_size = tweak_data.menu.pd2_small_font_size,
			x = host_text:left(),
			y = next_y,
			text = managers.localization:to_upper_text("menu_cn_skirmish"),
			color = tweak_data.screen_colors.skirmish_color
		})
		mw = math.max(mw, self:make_fine_text(skirmish_text))
		next_y = skirmish_text:bottom()
	
		local risk_icon = legend_panel:bitmap({
			texture = "guis/textures/pd2/crimenet_legend_risklevel",
			x = 10,
			y = next_y
		})
		local risk_text = legend_panel:text({
			blend_mode = "add",
			font = tweak_data.menu.pd2_small_font,
			font_size = tweak_data.menu.pd2_small_font_size,
			x = host_text:left(),
			y = next_y,
			text = managers.localization:to_upper_text("menu_cn_legend_risk"),
			color = tweak_data.screen_colors.risk
		})
		mw = math.max(mw, self:make_fine_text(risk_text))
		next_y = risk_text:bottom()
			
		local ghost_icon = legend_panel:bitmap({
			texture = "guis/textures/pd2/cn_minighost",
			x = 7,
			y = next_y + 4,
			color = tweak_data.screen_colors.ghost_color
		})
		local ghost_text = legend_panel:text({
			blend_mode = "add",
			font = tweak_data.menu.pd2_small_font,
			font_size = tweak_data.menu.pd2_small_font_size,
			x = host_text:left(),
			y = next_y,
			text = managers.localization:to_upper_text("menu_cn_legend_ghostable"),
			color = tweak_data.screen_colors.ghost_color
		})
		mw = math.max(mw, self:make_fine_text(ghost_text))
		next_y = ghost_text:bottom()
		local kick_none_icon = legend_panel:bitmap({
			texture = "guis/textures/pd2/cn_kick_marker",
			x = 10,
			y = next_y + 2
		})
		local kick_none_text = legend_panel:text({
			blend_mode = "add",
			font = tweak_data.menu.pd2_small_font,
			font_size = tweak_data.menu.pd2_small_font_size,
			x = host_text:left(),
			y = next_y,
			text = managers.localization:to_upper_text("menu_cn_kick_disabled")
		})
		mw = math.max(mw, self:make_fine_text(kick_none_text))
		local kick_vote_icon = legend_panel:bitmap({
			texture = "guis/textures/pd2/cn_votekick_marker",
			x = 10,
			y = kick_none_text:bottom() + 2
		})
		local kick_vote_text = legend_panel:text({
			blend_mode = "add",
			font = tweak_data.menu.pd2_small_font,
			font_size = tweak_data.menu.pd2_small_font_size,
			x = host_text:left(),
			y = kick_none_text:bottom(),
			text = managers.localization:to_upper_text("menu_kick_vote")
		})
		mw = math.max(mw, self:make_fine_text(kick_vote_text))
		local last_text = kick_vote_text
		local job_plan_loud_icon, job_plan_loud_text, job_plan_stealth_icon, job_plan_stealth_text = nil

		if MenuCallbackHandler:bang_active() then
			job_plan_loud_icon = legend_panel:bitmap({
				texture = "guis/textures/pd2/cn_playstyle_loud",
				x = 10,
				y = kick_vote_text:bottom() + 2
			})
			job_plan_loud_text = legend_panel:text({
				blend_mode = "add",
				font = tweak_data.menu.pd2_small_font,
				font_size = tweak_data.menu.pd2_small_font_size,
				x = host_text:left(),
				y = kick_vote_text:bottom(),
				text = managers.localization:to_upper_text("menu_plan_loud")
			})
			mw = math.max(mw, self:make_fine_text(job_plan_loud_text))
			job_plan_stealth_icon = legend_panel:bitmap({
				texture = "guis/textures/pd2/cn_playstyle_stealth",
				x = 10,
				y = job_plan_loud_text:bottom() + 2
			})
			job_plan_stealth_text = legend_panel:text({
				blend_mode = "add",
				font = tweak_data.menu.pd2_small_font,
				font_size = tweak_data.menu.pd2_small_font_size,
				x = host_text:left(),
				y = job_plan_loud_text:bottom(),
				text = managers.localization:to_upper_text("menu_plan_stealth")
			})
			mw = math.max(mw, self:make_fine_text(job_plan_stealth_text))
			last_text = job_plan_stealth_text
		end

		if managers.crimenet:no_servers() or is_xb1 then
			kick_none_icon:hide()
			kick_none_text:hide()
			kick_vote_icon:hide()
			kick_vote_text:hide()
			kick_vote_text:set_bottom(ghost_text:bottom())

			if MenuCallbackHandler:bang_active() then
				job_plan_loud_icon:hide()
				job_plan_loud_text:hide()
				job_plan_stealth_icon:hide()
				job_plan_stealth_text:hide()
			end
		end

		legend_panel:set_size(host_text:left() + mw + 10, last_text:bottom() + 10)
		legend_panel:rect({
			alpha = 0.4,
			layer = -1,
			color = Color.black
		})
		BoxGuiObject:new(legend_panel, {
			sides = {1, 1, 1, 1}
		})
		legend_panel:bitmap({
			texture = "guis/textures/test_blur_df",
			render_template = "VertexColorTexturedBlur3D",
			layer = -1,
			w = legend_panel:w(),
			h = legend_panel:h()
		})
		legend_panel:set_right(self._panel:w() - 10)
	end

	local data = CrimeNetGui.mouse_pressed
	function CrimeNetGui:mouse_pressed(o, button, x, y)
		for _, job in pairs(self._jobs) do
			if job.server and job.mouse_over == 1 then
				local allowed = self:input_focus()
				local button_pressed = allowed and Idstring("1") or Idstring("2")
				if button == button_pressed then
					local banned = managers.ban_list:banned(job.host_id)
					local dialog_data = {
						title = managers.localization:text(banned and "dialog_sure_to_unban_title" or "dialog_sure_to_ban_title"),
						text = managers.localization:text(banned and "dialog_sure_to_unban_body" or "dialog_sure_to_kick_ban_body", {
							USER = Steam:username(job.host_id) or ""
						})
					}
					local yes_button = {
						text = managers.localization:text("dialog_yes"),
						callback_func = function()
							if job then
								if managers.ban_list:banned(job.host_id) then
									managers.ban_list:unban(job.host_id)
								else
									managers.ban_list:ban(job.host_id, Steam:username(job.host_id))
								end
								self:update_nickname_color(job)
								self:update_nickname_in_the_ban_list(job)
							end
						end
					}
					local no_button = {
						text = managers.localization:text("dialog_no"),
						cancel_button = true
					}
					dialog_data.button_list = {
						yes_button,
						no_button
					}

					managers.system_menu:show(dialog_data)
				end
			end
			
			if job.server then
				self:update_nickname_color(job)
			end
		end

		return data(self, o, button, x, y)
	end

	function CrimeNetGui:update_all_job_guis(closest_job, inside_any_job)
		for id, job in pairs(self._jobs) do
			local inside = job == closest_job and 1 or inside_any_job and 2 or 3
			self:update_current_job_gui(job, inside)
		end
	end

	local data = CrimeNetGui.update_job_gui
	function CrimeNetGui:update_current_job_gui(job, inside)
		data(self, job, inside)
	end

	function CrimeNetGui:update_job_gui(job, inside)
		self:custom_gui(job)
	end

	function CrimeNetGui:custom_gui(job)
		local CNES = _G.CN_Enhanced.settings
		local steam_id = job.host_id or nil
		job.side_panel:child("stars_panel"):clear()
		
		if job.job_id then
			local x = 0
			local y = 0
			local difficulty_stars = job.difficulty_id - 2
			local start_difficulty = 1
			local num_difficulties = Global.SKIP_OVERKILL_290 and 5 or 6

			for i = start_difficulty, num_difficulties do
				job.side_panel:child("stars_panel"):bitmap({
					texture = "guis/textures/pd2/hud_difficultymarkers_2",
					h = 17,
					w = 18,
					layer = 0,
					x = x - 3,
					y = y - 3,
					rotation = 360,
					texture_rect = {
						i == 4 and 90 or i == 6 and 30 or 0,
						i >= 5 and 32 or 0,
						30,
						30
					},
					alpha = difficulty_stars < i and 0.5 or 1,
					blend_mode = difficulty_stars < i and "normal" or "add",
					color = difficulty_stars < i and Color.black or tweak_data.screen_colors.risk
				})

				x = x + 12
			end
			
		end
		
		if job.marker_panel and job.peers_panel then
			local avatar = "guis/textures/pd2/hud_icon_noreturnbox"
			Steam:friend_avatar(1, "76561198394078112", function(texture)
				avatar = texture
			end)
			
			Steam:friend_avatar(1, steam_id, function(texture)
				avatar = texture
			end)
		
			job.marker_dot:set_visible(false)
			job.peers_panel:set_visible(false)
			job.marker_panel:bitmap({
				texture = avatar,
				name = "avatar",
				x = 3,
				y = 3,
				h = 29,
				w = 29,
				alpha = 1,
				layer = 2,
				visible = not CNES.hide_avatar,
				blend_mode = "normal"
			})
			
			local in_game = tweak_data:server_state_to_index("in_game")
			local in_lobby = tweak_data:server_state_to_index("in_lobby")
			local box = job.marker_panel:bitmap({
				name = "avatar_box",
				texture = "server_frame",
				blend_mode = "normal",
				h = 64,
				y = 2,
				w = 32,
				x = 2,
				layer = 3,
				visible = not CNES.hide_avatar,
				rotation = 360
			})
			box:set_color(job.state == in_game and Color(255, 163, 209, 93) / 255 or job.state == in_lobby and Color(255, 114, 198, 255) / 255 or Color.white)
			
			local x = 8
			for i = 1, 4 do
				job.marker_panel:bitmap({
					name = "peer_count_"..i,
					texture = "guis/textures/pd2/crimenet_marker_peerflag",
					x = x,
					y = 33,
					blend_mode = "normal",
					layer = 2,
					rotation = 360,
					h = 7,
					w = 5,
					layer = 4,
					visible = not CNES.hide_avatar,
					color = job.num_plrs < i and Color.black:with_alpha(0.45) or Color.black
				})
				x = x + 5
			end
		end

		if job then
			self:update_nickname_color(job)
			self:update_nickname_in_the_ban_list(job)
		end
	end
	
	function CrimeNetGui:update_nickname_color(job)
		local host = job.side_panel:child("host_name")
		local have_mods = job.mods and job.mods ~= "" and job.mods ~= "1"
		if host then
			if managers.ban_list:banned(job.host_id) then
				host:set_color(tweak_data.screen_colors.achievement_grey:with_alpha(0.5))
			elseif managers.crimenet:unacceptable_mods_found(job) then
				host:set_color(tweak_data.screen_colors.pro_color)
			elseif job.is_friend then
				host:set_color(tweak_data.screen_colors.friend_color)
			elseif have_mods then
				host:set_color(tweak_data.screen_colors.regular_color)
			else
				host:set_color(tweak_data.screen_colors.crimenet_lines)
			end
		end
	end

	function CrimeNetGui:update_nickname_in_the_ban_list(job)
		for id, banned in pairs(managers.ban_list:ban_list()) do
			if banned.name ~= Steam:username(banned.identifier) then
				banned.name = Steam:username(banned.identifier)
			end
		end
	end
	
	function CrimeNetManager:unacceptable_mods_found(lobby)
		local function precise(text)
			return text:gsub("%p", "").."  "
		end
		
		local modded = lobby.mods
		if modded then
			local mods = string.upper(modded):gsub("|", "  ")
			local mods_blacklist = _G.CN_Enhanced.Options:GetValue("mods_blacklist")
			for _, blacklisted_mod in pairs(mods_blacklist) do
				if string.find(precise(mods), precise(string.upper(blacklisted_mod))) then
					return true
				elseif string.find(precise(mods), precise(string.upper(blacklisted_mod))) then
					return false
				end
			end
		end
	end
end